
import numpy as  np
import matplotlib.cm as cm
import torch
import torch.nn as nn
from   torch.nn import Parameter
from model_fitting import fit_model

class Model(nn.Module) :
    "Abstract, scikit-learn like model class."
    def __init__(self) :
        super(Model, self).__init__()

    def __call__(self, params_shoot) :
        "Applies the model on some point cloud."
        raise NotImplementedError
    
    def cost(self, target) :
        "Returns a cost to optimize."
        raise NotImplementedError

    def fit(self, target, **kwargs) :
        fit_model(self, target, **kwargs)
