def K_xx(x_i, σ = .1) :
    return (-sqdistances(x_i,x_i)/σ**2 ).exp()

class KernelRegistration(Model) :
    "Find the optimal mass positions."
    def __init__(self, α) :
        "Defines the parameters of a free deformation of α."
        super(Model, self).__init__()
        self.α, self.x = α[0].detach(), α[1].detach()
        self.p = Parameter(torch.zeros_like(self.x))

    def __call__(self, t=1.) :
        "Applies the model on some point cloud, an N-by-2 tensor."
        x_t =  self.x + K_xx(self.x) @ (t*self.p)
        return self.α, x_t 
    
    def cost(self, target) :
        "Returns a cost to optimize."
        data = fidelity( self(), target)
        reg_geom = .5*scal( self.p, K_xx(self.x) @ self.p)
        return 1000*data + reg_geom
    
k_reg = train_and_display(KernelRegistration, α, β)
