class GeodesicRegistration(Model) :
    "Find the optimal mass positions."
    def __init__(self, α) :
        "Defines the parameters of a free deformation of α."
        super(Model, self).__init__()
        self.α_i, self.q_0 = α[0].detach(), α[1].detach()
        self.q_0.requires_grad = True
        self.p_0 = Parameter(torch.zeros_like(self.q_0))

    def __call__(self, t=1.) :
        "Applies the model on some point cloud, an N-by-2 tensor."
        return self.α_i, Exp(self.q_0, t*self.p_0)
    
    def cost(self, target) :
        "Returns a cost to optimize."
        data = fidelity( self(), target)
        reg_geom = H(self.q_0, self.p_0)
        return 1000*data + reg_geom
    
g_reg = train_and_display(GeodesicRegistration, α, β)
